<template>
  <div id="tag-selection-dropdown">
    <vs-dropdown vs-custom-content vs-trigger-click class="w-full ">
      <div
        class="w-full flex flex-row p-5 justify-between cursor-pointer"
        @click.stop="null"
      >
        <div class="flex">
          <feather-icon
            icon="TagIcon"
            :svgClasses="['stoke-current text-muted']"
            class="pr-2"
          />
          <p
            class="text-muted mt ml-2"
            style="font-family: 'Montserrat', Helvetica, Arial, sans-serif !important;"
          >
            Gắn thẻ
          </p>
        </div>
        <feather-icon
          icon="ChevronDownIcon"
          :svgClasses="['stoke-current text-dark']"
          class="w-5 h-5"
          @click.stop="null"
        />
      </div>

      <vs-dropdown-menu style="z-index: 200001; width: 260px !important;">
        <div class="flex justify-between items-end p-5">
          <div class="h5 font-bold">Gắn Thẻ</div>
          <!-- <div
            class="underline text-muted ml-auto"
            @click="activeManageTool = !activeManageTool"
          >
            Quản lý
          </div> -->
          <feather-icon
            icon="ToolIcon"
            :svgClasses="
              `w-5 h-5 cursor-pointer hover:text-primary  ${
                activeManageTool ? 'text-primary' : 'text-grey'
              }`
            "
            href.prevent
            @click.stop="activeManageTool = !activeManageTool"
          />
        </div>

        <!-- SEARCH BAR -->
        <vs-input
          icon-no-border
          size="large"
          icon-pack="feather"
          icon="icon-search"
          placeholder="Tìm kiếm..."
          v-model="searchQuery"
          class="vs-input-no-border vs-input-no-shdow-focus w-full"
        />

        <!-- TAG OPTIONS -->
        <div v-if="taskTags.length > 0" class="mb-5">
          <VuePerfectScrollbar
            class="scroll-area--data-list-add-new scroll-container "
            :settings="settings"
            :key="$vs.rtl"
            ref="formPS"
          >
            <div class="tag-options" style="height: 150px;">
              <div v-for="(tag, index) in taskTags" :key="index">
                <div class="mt-5 w-full flex justify-between">
                  <vs-checkbox
                    :disabled="selectedId == tag._id"
                    :vs-value="tag._id"
                    v-model="labelIdsLocal"
                  >
                    <vs-input
                      v-if="selectedId == tag._id"
                      icon-no-border
                      placeholder="Tên thẻ"
                      v-model="labelLocal.name"
                      class="vs-input-no-border vs-input-no-shdow-focus w-full"
                      v-on:keyup.native.enter="onEnter($event)"
                    />
                    <div v-else>{{ tag.name }}</div></vs-checkbox
                  >

                  <div v-if="activeManageTool" class="flex items-center">
                    <vs-button
                      v-if="selectedId == tag._id"
                      radius
                      type="flat"
                      color="dark"
                      icon-pack="feather"
                      icon="icon-x"
                      size="small"
                      @click.stop="selectedId = null"
                    />
                    <vs-button
                      radius
                      type="flat"
                      color="primary"
                      icon-pack="feather"
                      icon="icon-edit"
                      size="small"
                      @click.stop="onClickEdit(tag)"
                    />
                    <vs-button
                      radius
                      type="flat"
                      color="danger"
                      icon-pack="feather"
                      icon="icon-trash-2"
                      size="small"
                      @click="onClickDelete(tag)"
                    />
                  </div>
                </div>
              </div>
            </div>
          </VuePerfectScrollbar>
        </div>

        <div v-else class="text-center py-10">
          <img
            src="@/assets/images/elements/tag-icon.jpg"
            alt="graphic-404"
            class="mx-auto mb-4 w-1/3 opacity-75"
          />
          <div>
            Chưa có thẻ nào.
          </div>
        </div>

        <!-- ADD TAG BUTTON -->
        <vs-button
          v-if="activeManageTool && !activeAddNewForm"
          type="line"
          icon-pack="feather"
          icon="icon-plus"
          line-position="top"
          line-origin="left"
          color="primary"
          class="w-full"
          @click.stop="activeAddNewForm = !activeAddNewForm"
        >
          Thêm nhanh thẻ
        </vs-button>

        <div
          v-if="activeManageTool && activeAddNewForm"
          class="flex items-center"
        >
          <!-- Name -->
          <vs-input
            v-validate="'required'"
            name="title"
            class="w-full mb-4 mt-5"
            placeholder="Tiêu đề thẻ"
            v-model="labelLocal.name"
            :color="isValid ? 'success' : 'danger'"
          />
          <!-- /Name -->

          <vs-button
            @click.stop="onClickAdd"
            radius
            icon-pack="feather"
            icon="icon-send"
            size="small"
            class="ml-2"
          ></vs-button>
          <vs-button
            @click.stop="activeAddNewForm = !activeAddNewForm"
            radius
            color="danger"
            type="gradient"
            icon-pack="feather"
            icon="icon-x"
            size="small"
            class="ml-2"
          ></vs-button>
        </div>
      </vs-dropdown-menu>
    </vs-dropdown>
  </div>
</template>

<script>
import _clone from "lodash/clone";
import VuePerfectScrollbar from "vue-perfect-scrollbar";
import LabelService from "../../../services/LabelService";

export default {
  name: "tag-selection-dropdown",
  components: { VuePerfectScrollbar },
  props: {
    value: { type: Array, default: () => [] },
    isValid: { type: Boolean, default: true }
  },
  // data() {
  //   return {
  //     labelIdsLocal: this.value
  //   };
  // },
  computed: {
    labelIdsLocal: {
      get() {
        return this.value;
      },
      set(val) {
        console.log(val);
        this.$emit("input", val);
      }
    },
    taskTags() {
      return this.$store.getters["todo/queriedTags"];
      // return this.$store.state.todo.taskTags;
    },
    searchQuery: {
      get() {
        return this.$store.state.todo.tagSearchQuery;
      },
      set(val) {
        this.$store.dispatch("todo/setTagSearchQuery", val);
      }
    },
    validateForm() {
      return !this.errors.any() && this.labelLocal.name != "";
    }
  },
  data() {
    return {
      activeManageTool: true,
      activeAddNewForm: false,
      selectedId: null,
      settings: {
        // perfectscrollbar settings
        maxScrollbarLength: 60,
        wheelSpeed: 0.6
      },
      labelLocal: {
        name: "",
        isFavorite: false,
        color: "charcoal"
      }
    };
  },
  methods: {
    clearFields() {
      Object.assign(this.labelLocal, {
        name: "",
        isFavorite: false,
        color: "charcoal"
      });
    },
    async onClickAdd() {
      const isValid = this.validateForm();

      if (!isValid) {
        alert("Vui lòng nhập nội dung!");
        return;
      }

      this.$validator.validateAll().then(async result => {
        if (result) {
          try {
            const res = await LabelService.create(this.labelLocal);

            this.$success(res.message);

            // Fetch Tags
            this.$store.dispatch("todo/fetchTags");

            this.activeAddNewForm = false;
          } catch (error) {
            this.$error(error.message);
          }

          // Clear field
          this.clearFields();
        }
      });
    },
    async onClickEdit(item) {
      this.selectedId = item._id;
    },
    async onClickDelete(item) {
      var yes = confirm("Bạn có chắc chắn muốn xóa thẻ này không?");
      if (!yes) return;

      try {
        const res = await LabelService.delete(item._id);
        this.$success(res.message);

        // Fetch Tags
        this.$store.dispatch("todo/fetchTags");
      } catch (error) {
        this.$error(error.message);
      }
    },
    onEnter(e) {
      const isValid = e.target.value.trim() !== "";
      if (!isValid) {
        alert("Vui lòng nhập nội dung!");
        return;
      }

      this.$validator.validateAll().then(async result => {
        if (result) {
          try {
            const res = await LabelService.update(this.selectedId, {
              name: e.target.value
            });

            this.$success(res.message);

            // Fetch Tags
            this.$store.dispatch("todo/fetchTags");
            // Reset and toggle form to hide
            this.selectedId = null;
          } catch (error) {
            this.$error(error.message);
          }

          // Clear field
          this.clearFields();
        }
      });
    }
  },
  mounted() {
    this.$store.dispatch("todo/setTagSearchQuery", "");
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/apps/todo.scss";
.vs-notifications {
  z-index: 200002 !important;
}

.scroll-container {
  color: inherit;
  position: relative;
  padding-left: 0.7rem;
  padding-right: 0.7rem;
  font-size: 1rem;
  border-radius: 5px;
  border: 1px solid rgba(0, 0, 0, 0.2);
  box-shadow: 0 0 0 0 rgba(0, 0, 0, 0.15);
  transition: all 0.3s ease;
  width: 100%;
}
</style>
